<?php

namespace Teknisa\EST\Services;

class Ger03700AlmoxarifadoLocalizacao {

	protected $Ger03700Factory;
	protected $nrorg;
	protected $connection;

	public function __construct($Ger03700Factory, $environment, $entityManager) {
		$this->Ger03700Factory = $Ger03700Factory;
		$this->nrorg = $environment->getNrOrgTrab();
		$this->connection = $entityManager->getConnection();
	}

	public function updateLocalEstoque($row){
		$this->Ger03700Factory->updateLocalEstoque($row['IDCHECK'], $row['CDALMOXARIFE'], $row['CDFILIAL'], $this->nrorg);
	}

	public function checaAlmoxarifadoPadrao($cdfilial, $cdalmoxarife){
		$padroes = $this->Ger03700Factory->selectAlmoxarifadoLocalizacaoPadrao($cdfilial, $this->nrorg);
		if(!empty($padroes)){
			if($padroes[0]['CDALMOXARIFE'] === $cdalmoxarife){
				throw new \Exception("Operação bloqueada! Almoxarifado parametrizado por filial padrão.", 1);
			}
		}
	}

	public function checaLocalizacaoPadrao($cdfilial, $cdlocalestoq){
		$padroes = $this->Ger03700Factory->selectAlmoxarifadoLocalizacaoPadrao($cdfilial, $this->nrorg);
		if(!empty($padroes)){
			if($padroes[0]['CDLOCALESTOQ'] === $cdlocalestoq){
				throw new \Exception("Operação bloqueada! Localização parametrizado por filial padrão.", 1);
			}
		}
	}

	public function deleteAllLocalizacoes($cdfilial, $cdalmoxarife){
		$almoxarifados = $this->Ger03700Factory->selectAllLocalizacoes($cdalmoxarife, $cdfilial, $this->nrorg);
		
		if(!empty($almoxarifados)){
			try{
				for ($i=0; $i < count($almoxarifados) ; $i++) {
					$this->Ger03700Factory->deleteAllLocalizacoes(''.$almoxarifados[$i]['CDALMOXARIFE'], ''.$almoxarifados[$i]['CDFILIAL'], $this->nrorg, ''.$almoxarifados[$i]['CDLOCALESTOQ']);
				}
			} catch (\Exception $e){
				if(strpos($e->getMessage(), 'ORA-02292') === false){
					$str = $e->getMessage();
				} else {
					$str = "Exclusão bloqueada! Existem restrições na base de dados que impedem a exclusão da localização.";
				}
				throw new \Exception($str, 1);
				$this->connection->rollBack();
			}
		}
	}
	
	public function deleteAlmoxarifado($cdfilial, $cdalmoxarife, $nrorg){
	    try{
				$this->Ger03700Factory->deleteAlmoxarifado($cdalmoxarife, $cdfilial, $nrorg);
				
			} catch (\Exception $e){
				if(strpos($e->getMessage(), 'ORA-02292') === false){
					$str = $e->getMessage();
				} else {
					$str = "Exclusão bloqueada! Existem restrições na base de dados que impedem a exclusão do almoxarifado.";
				}
				throw new \Exception($str, 1);
				$this->connection->rollBack();
			}
	}
}